Package: QuantLib
Title: QuantLib bindings for R
Version: 1.43
Date: $Date$
Maintainer: Dirk Eddelbuettel <edd@debian.org>
Author: The QuantLib Group
Description: This package provides the SWIG-generated QuantLib bindings for R
Depends: methods
SystemRequirements: QuantLib library, Boost library
License: QuantLib License
URL: https://www.quantlib.org 

QuantLib-SWIG: language bindings for QuantLib
=============================================

[![Download source](https://img.shields.io/github/v/release/lballabio/QuantLib-SWIG?label=source&sort=semver)](https://github.com/lballabio/QuantLib-SWIG/releases/latest)
[![PyPI version](https://img.shields.io/pypi/v/quantlib?label=PyPI)](https://pypi.org/project/QuantLib)
![PRs Welcome](https://img.shields.io/badge/PRs%20-welcome-brightgreen.svg)
[![DOI](https://zenodo.org/badge/DOI/10.5281/zenodo.1441003.svg)](https://doi.org/10.5281/zenodo.1441003)
[![Build status](https://github.com/lballabio/QuantLib-SWIG/workflows/Linux%20build/badge.svg?branch=master)](https://github.com/lballabio/QuantLib-SWIG/actions?query=workflow%3A%22Linux+build%22)
[![Binder](https://mybinder.org/badge_logo.svg)](https://mybinder.org/v2/gh/lballabio/QuantLib-SWIG/binder?urlpath=lab/tree/Python/examples)

---

The QuantLib project (<https://www.quantlib.org>) is aimed at providing a
comprehensive software framework for quantitative finance. QuantLib is
a free/open-source library for modeling, trading, and risk management
in real-life.

QuantLib is Non-Copylefted Free Software and OSI Certified Open Source
Software.

QuantLib-SWIG provides the means to use QuantLib from a number of
languages; currently their list includes Python, C#, Java, Scala and R.


Questions and feedback
----------------------

Bugs can be reported as a GitHub issue at
<https://github.com/lballabio/QuantLib-SWIG/issues>; if you have a
patch available, you can open a pull request instead (see
"Contributing" below).

You can also use the `quantlib-users` and `quantlib-dev` mailing lists
for feedback, questions, etc.  More information and instructions for
subscribing are at <https://www.quantlib.org/mailinglists.shtml>.


Contributing
------------

The easiest way to contribute is through pull requests on GitHub.  Get
a GitHub account if you don't have it already and clone the repository
at <https://github.com/lballabio/QuantLib-SWIG> with the "Fork" button
in the top right corner of the page. Check out your clone to your
machine, code away, push your changes to your clone and submit a pull
request; instructions are available at
<https://help.github.com/articles/fork-a-repo>.  (In case you need
them, more detailed instructions for creating pull requests are at
<https://help.github.com/articles/using-pull-requests>, and a basic
guide to GitHub is at
<https://guides.github.com/activities/hello-world/>.

It's likely that we won't merge your code right away, and we'll ask
for some changes instead. Don't be discouraged! That's normal; the
library is complex, and thus it might take some time to become
familiar with it and to use it in an idiomatic way.

We're looking forward to your contributions.

QuantLib-SWIG: language bindings for QuantLib
=============================================

QuantLib-SWIG provides the means to use QuantLib from a number of
languages including Python, Ruby, Perl, C# and Java.

The QuantLib project (<http://quantlib.org>) is aimed at providing a
comprehensive software framework for quantitative finance. QuantLib is
a free/open-source library for modeling, trading, and risk management
in real-life.

QuantLib is Non-Copylefted Free Software and OSI Certified Open Source
Software.


Download and usage
------------------

QuantLib-SWIG can be downloaded from <http://quantlib.org/download.shtml>.

On Linux/Unix, you can run:

    ./configure
    make
    make check
    sudo make install

to build, test and install al modules. If you're only interested in a
specific language, you can tell make to only work in its subdirectory,
as in:

    make -C Python

Alternatively, you can cd to a specific subdirectory and follow the
instructions in its README file. This is also the procedure for
Windows users.


Questions and feedback
----------------------

Bugs can be reported as a GitHub issue at
<https://github.com/lballabio/QuantLib-SWIG/issues>; if you have a
patch available, you can open a pull request instead (see
"Contributing" below).

You can also use the `quantlib-users` and `quantlib-dev` mailing lists
for feedback, questions, etc.  More information and instructions for
subscribing are at <http://quantlib.org/mailinglists.shtml>.


Contributing
------------

The easiest way to contribute is through pull requests on GitHub.  Get
a GitHub account if you don't have it already and clone the repository
at <https://github.com/lballabio/QuantLib-SWIG> with the "Fork" button
in the top right corner of the page. Check out your clone to your
machine, code away, push your changes to your clone and submit a pull
request; instructions are available at
<https://help.github.com/articles/fork-a-repo>.  (In case you need
them, more detailed instructions for creating pull requests are at
<https://help.github.com/articles/using-pull-requests>, and a basic
guide to GitHub is at
<https://guides.github.com/activities/hello-world/>.

It's likely that we won't merge your code right away, and we'll ask
for some changes instead. Don't be discouraged! That's normal; the
library is complex, and thus it might take some time to become
familiar with it and to use it in an idiomatic way.

We're looking forward to your contributions.

The C++ wrappers for the QuantLib-Python extension module are created
by means of SWIG (Simplified Wrapper and Interface Generator)
available from <http://www.swig.org/>; the latest version is suggested.

Building the wrappers requires the Setuptools package.

Generating the wrappers is not required if you are using a distributed
tarball. If you're building from a Git checkout, instead, use the
command:

    python setup.py wrap

The commands to be issued for building and testing the
wrappers are:

    python setup.py build
    python setup.py test

respectively.

The build step requires that the QuantLib headers and library can be
found by the compiler. On Unix-like platforms, this requires that
`quantlib-config` is in your path. On the Windows platform, instead,
it requires you to define a `QL_DIR` environment variable pointing to
your QuantLib directory (e.g., `C:\Lib\QuantLib`.)

The suggested way to install the module is to run first

    python setup.py bdist_wheel

which requires the wheel module to be available and which will create
a QuantLib wheel in the dist folder.  The resulting wheel can then
be installed with pip in the desired environment.

The test suite is implemented on top of the PyUnit framework, which is
included in the Python standard library.

On Linux systems, the module can be build by supplying the location of
the JDK to configure, as in (for example)

./autogen.sh
./configure --with-jdk-include=/usr/lib/jvm/java-1.5.0-sun-1.5.0.08/include \
  --with-jdk-system-include=usr/lib/jvm/java-1.5.0-sun-1.5.0.08/include/linux

and by running 'make' afterwards.

This is an experimental SWIG interface between perl and QuantLib. See
<joe@confucius.gnacademy.org> for more details.

Running 'make' in this directory will build the module; 'make install'
will make it available on your system.c

Updated July 2013

The new build process creates sources for a standard R packages which can
be installed from this directory via

   R CMD INSTALL .

Dirk Eddelbuettel 
edd@debian.org

========================================================================
This is the R interface to QuantLib. The needed C++ bindings are created
by means of SWIG (Simplified Wrapper and Interface Generator) available
from <http://swig.sourceforge.net/>. SWIG version 1.3.32 is needed.

SWIG 1.3.31 generates a .R called QuantLib_wrap.R instead of
QuantLib.R.  The Makefile.am and makeRData.R has commented sections
which can be used with SWIG 1.3.31

The command

   make

generates the R library QuantLib.so and the wrapper script 
QuantLib_wrap.R and a compiled wrapper QuantLib.RData.

Once you've compiled this you can load with

  dyn.load('QuantLib.so')
  load('QuantLib.RData')
  cacheMetaData(1)

The last line is to work around a bug that causes S4 methods not to
get loaded correctly.

You can also load the uncompiled wrapper file

  dyn.load('QuantLib_wrap.so')
  source('QuantLib.R')

Please contact 

Joseph Wang - joequant@gmail.org


if you have any comments or additions.

The C++ wrappers for the QuantLib-Python extension module are created
by means of SWIG (Simplified Wrapper and Interface Generator)
available from <http://www.swig.org/>; the latest version is suggested.

Building the wrappers requires the `setuptools` and `build` packages;
both can be installed (preferably in a virtual environment) by means
of `pip install`.

Generating the wrappers is not required if you are using a distributed
tarball. If you're building from a Git checkout, instead, use the
command `swig.cmd` on Windows or `make` on other platforms.  Running
`make` also builds the wrappers as a wheel; on Windows, this requires
the explicit command `python -m build --wheel` instead.

The build step requires that the QuantLib headers and library can be
found by the compiler. On Unix-like platforms, this requires that
`quantlib-config` is in your path. On the Windows platform, instead,
it requires you to define a `QL_DIR` environment variable pointing to
your QuantLib directory (e.g., `C:\Lib\QuantLib`.) Another environment
variable `QL_DEBUG` on Windows should be set to `TRUE` if you are building
against a debug version of QuantLib with the objective to
debug the library called from Python. On Unix-like platforms, appropriate flags
can be setup in `CXXFLAGS` and `LDFLAGS`. If boost is required for compilation,
it can be set via the environment variable `INCLUDE`.


Once built, the resulting wheel can be installed with `pip`.

Finally, testing the wheel requires `tox`, also available via
`pip install`.  Once available, running `tox run` will run the
test suite.

Visual Studio .NET projects are provided; note that before launching
the IDE, you'll have to define an environment variable QL_DIR whose
value must equal the path to your QuantLib installation, e.g.,
"C:\Lib\QuantLib".

The interfaces also work with .Net on Linux and macOS; run 'make' in
this directory after running './autogen.sh' and './configure' in the
main QuantLib-SWIG directory.

The C++ wrappers for the QuantLib-Ruby extension module are created
by means of SWIG (Simplified Wrapper and Interface Generator) available
from <http://swig.sourceforge.net/>. SWIG version 1.3.31 is needed.

The wrappers are generated on all supported platforms by issuing the command
    ruby setup.rb wrap
The above assumes that the SWIG executable is named "swig" and can be found
in the system path. However, this step is only necessary if you are compiling
from sources checked out from the CVS repository. It is not required if you
are using a distributed tarball.

The building and installation process consists of the following commands:
    ruby setup.rb build
    ruby setup.rb test
    ruby setup.rb install

The build step requires that the QuantLib headers and library can be
found by the compiler. On Unix-like platforms, this should already
hold if you ran "make install" from your QuantLib directory. On the
Windows platform, this can be achieved by defining a QL_DIR environment
variable pointing to your QuantLib directory (e.g., "C:\Lib\QuantLib".)

The install step might require superuser privileges.
An alternate install location can be specified with the command:
    ruby setup.rb install --prefix=/home/johndoe

The test suite is implemented on top of the Test::Unit framework, included
in the standard Ruby distribution since version 1.8.0. A version of Test::Unit 
for Ruby 1.6.x is available from <http://testunit.talbott.ws>. 

# QuantLib: the free/open-source library for quantitative finance

The QuantLib project (<https://www.quantlib.org>) is aimed at providing a comprehensive software framework for quantitative finance. QuantLib is a free/open-source library for modeling, trading, and risk management in real-life.

QuantLib is Non-Copylefted Free Software and OSI Certified Open Source Software.


## Note on multi-threading

The underlying C++ library is not thread-safe.  However, it provides some configuration options that make it possible to use these wrappers from C# using some limited multi-threading.  In particular:

- the globals in the library are per-thread; most notably, the evaluation date and the stored index fixings;
- there is code in place to prevent the garbage collector to interfere with notifications inside the library.


Any more complex attempt at multi-threading will probably fail.  We suggest to avoid sharing objects and state across threads; each thread should have its set of objects, evaluation date etc.

# QuantLib Python examples

[![Binder](https://mybinder.org/badge_logo.svg)](https://mybinder.org/v2/gh/lballabio/QuantLib-SWIG/binder?urlpath=lab/tree/Python/examples)

This directory contains a number of examples of using QuantLib from
Python.  They can also run as Jupyter notebooks by means of
[Jupytext](https://jupytext.readthedocs.io/).

You can try them online thanks to [Binder](https://mybinder.org/).
If you're seeing this file as a notebook, you're probably there already.
If not, you can click the "Launch Binder" badge at the top of this file.

If you want to run these examples locally, you'll need the modules listed in the
`requirements.txt` file in the `binder` folder at the root of the [QuantLib-SWIG
repository](https://github.com/lballabio/QuantLib-SWIG); to install
them, you can execute

    pip install -r requirements.txt

from that directory.

# inspired by python example with the same name

suppressMessages(library(QuantLib))

## global data
calendar <- TARGET()

todaysDate <- DateParser_parseISO("2001-09-06")
invisible(Settings_instance()$setEvaluationDate(d=todaysDate))

settlementDays = 2
settlementDate = Calendar_advance(calendar, todaysDate, settlementDays, "Days")

cat('Today          : ', Date_ISO(todaysDate), "\n")
cat('Settlement Date: ', Date_ISO(settlementDate), "\n")


# ### Market quotes

# %%
deposits = list(
  "3M" = 0.0363
)

# %%
FRAs = list(
  "3x6" = 0.037125,
  "6x9" = 0.037125,
  "9x12" =0.037125
)


# %%
futures = list(
  "2001-12-19" = 96.2875,
  "2002-03-20" = 96.7875,
  "2002-06-19" = 96.9875,
  "2002-09-18" = 96.6875,
  "2002-12-18" = 96.4875,
  "2003-03-19" = 96.3875,
  "2003-06-18" = 96.2875,
  "2003-09-17" = 96.0875
)

# %%
swaps = list(
#  "2Y" = 0.037125,
  "3Y" = 0.0398,
  "5Y" = 0.0443,
  "10Y" = 0.05165,
  "15Y" = 0.055175
  
)

allHelpers_DepoFutSwap = RateHelperVector()
allHelpers_DepoFraSwap = RateHelperVector()

# Rate Helpers - Depos

for (it in names(deposits)) {
  itVal = deposits[[it]]  
  
  dayCounter = Actual360()
  
  dh = DepositRateHelper(
      QuoteHandle(SimpleQuote(itVal)),
      PeriodParser_parse(it),
      settlementDays,
      calendar,
      "ModifiedFollowing",
      F,
      dayCounter
    )  
  
  RateHelperVector_append(allHelpers_DepoFutSwap, dh)
  RateHelperVector_append(allHelpers_DepoFraSwap, dh)
}

# Rate Helpers - FRAs

for (it in names(FRAs)) {
  itVal = FRAs[[it]]  
  
  itSplit = strsplit(x = it, split = "x", fixed = T)[[1]]
  n = as.numeric(itSplit[1])
  m = as.numeric(itSplit[2])
  
  dayCounter = Actual360()
  months = 3

  dh = FraRateHelper(
    QuoteHandle(SimpleQuote(itVal)), n, m, settlementDays, calendar, "ModifiedFollowing", F, dayCounter
  )
  
  RateHelperVector_append(allHelpers_DepoFraSwap, dh)
}
  
  
# Rate Helpers - Futures

for (it in names(futures)) {
  itVal = futures[[it]]  

  dayCounter = Actual360()
  months = 3

  dh = FuturesRateHelper(
    QuoteHandle(SimpleQuote(itVal)),
    DateParser_parseISO(it),
    months,
    calendar,
    "ModifiedFollowing",
    T,
    dayCounter,
    QuoteHandle(SimpleQuote(0.0))    
  )
  
  RateHelperVector_append(allHelpers_DepoFutSwap, dh)
}


# 
# The discount curve for the swaps will come from elsewhere. 
# -> A real application would use some kind of risk-free curve; here we're using a flat one for convenience.
#

# %%
discountTermStructure = YieldTermStructureHandle(FlatForward(settlementDate, 0.04, Actual360()))

# %%

fixedLegFrequency = "Annual"
fixedLegTenor = PeriodParser_parse("1Y") 
fixedLegAdjustment = "Unadjusted"
fixedLegDayCounter = Thirty360(Thirty360_BondBasis_get())
floatingLegFrequency = "Quarterly"
floatingLegTenor = PeriodParser_parse("3M")
floatingLegAdjustment = "ModifiedFollowing"

for (it in names(swaps)) {
  itVal = swaps[[it]]  
  
  dh = SwapRateHelper(
    QuoteHandle(SimpleQuote(itVal)),
    PeriodParser_parse(it),
    calendar,
    fixedLegFrequency,
    fixedLegAdjustment,
    fixedLegDayCounter,
    Euribor3M(),
    QuoteHandle(),
    PeriodParser_parse("0D"),
    discountTermStructure
  )
  
  RateHelperVector_append(allHelpers_DepoFutSwap, dh)
  RateHelperVector_append(allHelpers_DepoFraSwap, dh)
}

# ### Term structure construction

printCurve <- function(curve, helpers) {
  df = NULL
  for (i in seq(1, helpers$size())) {
    h = helpers[i][[1]]
    pillar = RateHelper_pillarDate(h)

    day_counter = Actual365Fixed()
    compounding = "Continuous"
    
    r = YieldTermStructure_zeroRate(curve, pillar, day_counter, compounding, "Annual")
    disc = YieldTermStructure_discount(curve, pillar)
    
    df = rbind(df, data.frame(
      pillar=Date_ISO(pillar), zeroRate=InterestRate_rate(r)*100.0, df=disc, impliedRate=RateHelper_impliedQuote(h)
    ))
  }
  print(df)
}


# %%
forecastTermStructure = RelinkableYieldTermStructureHandle()

# %%
depoFuturesSwapCurve = PiecewiseFlatForward(settlementDate, allHelpers_DepoFutSwap, Actual360())
printCurve(depoFuturesSwapCurve, allHelpers_DepoFutSwap)


# %%
depoFraSwapCurve = PiecewiseFlatForward(settlementDate, allHelpers_DepoFraSwap, Actual360())
printCurve(depoFraSwapCurve, allHelpers_DepoFraSwap)



# ### Swap pricing

# %%
swapEngine = DiscountingSwapEngine(discountTermStructure)

# %%
nominal = 1000000
length = 5
maturity = Calendar_advance(calendar, settlementDate, length, "Years")
payFixed = T

# %%
fixedLegFrequency = "Annual"
fixedLegAdjustment = "Unadjusted"
fixedLegDayCounter = Thirty360(Thirty360_BondBasis_get())
fixedRate = swaps[["5Y"]] # 0.04

# %%
floatingLegFrequency = "Quarterly"
spread = 0.0
fixingDays = 2
index = Euribor3M(forecastTermStructure)
floatingLegAdjustment = "ModifiedFollowing"
floatingLegDayCounter = index$dayCounter()

# %%
fixedSchedule = Schedule(
    settlementDate,
    maturity,
    fixedLegTenor,
    calendar,
    fixedLegAdjustment,
    fixedLegAdjustment,
    DateGeneration_Forward_get(),
    F
)
floatingSchedule = Schedule(
    settlementDate,
    maturity,
    floatingLegTenor,
    calendar,
    floatingLegAdjustment,
    floatingLegAdjustment,
    DateGeneration_Forward_get(),
    F
)

# We'll build a 5-years swap starting spot...

# %%
spot = VanillaSwap(
    Swap_Payer_get(),
    nominal,
    fixedSchedule,
    fixedRate,
    fixedLegDayCounter,
    floatingSchedule,
    index,
    spread,
    floatingLegDayCounter
)
spot$setPricingEngine(swapEngine)



# ...and one starting 1 year forward.

# %%
forwardStart = Calendar_advance(calendar, settlementDate, 1, "Years")
forwardEnd = Calendar_advance(calendar, forwardStart, length, "Years")
fixedSchedule = Schedule(
    forwardStart,
    forwardEnd,
    fixedLegTenor,
    calendar,
    fixedLegAdjustment,
    fixedLegAdjustment,
    DateGeneration_Forward_get(),
    F
)
floatingSchedule = Schedule(
    forwardStart,
    forwardEnd,
    floatingLegTenor,
    calendar,
    floatingLegAdjustment,
    floatingLegAdjustment,
    DateGeneration_Forward_get(),
    F
)

# %%
forward = VanillaSwap(
    Swap_Payer_get(),
    nominal,
    fixedSchedule,
    fixedRate,
    fixedLegDayCounter,
    floatingSchedule,
    index,
    spread,
    floatingLegDayCounter
)
forward$setPricingEngine(swapEngine)


# We'll price them both on the bootstrapped curves.
#
# This is the quoted 5-years market rate; we expect the fair rate of the spot swap to match it.

# %%
print(swaps["5Y"])

showSwap <- function(swap) {
  print(paste("NPV         = ", swap$NPV()))
  print(paste("Fair spread = ", (swap$fairSpread()*100)))
  print(paste("Fair rate   = ", (swap$fairRate()*100)))
}


# %% [markdown]
# These are the results for the 5-years spot swap on the deposit/futures/swap curve...

# %%
forecastTermStructure$linkTo(depoFuturesSwapCurve)
showSwap(spot)

# ...and these are on the deposit/fra/swap curve.

# %%
forecastTermStructure$linkTo(depoFraSwapCurve)
showSwap(spot)

# %% [markdown]
# The same goes for the 1-year forward swap, except for the fair rate not matching the spot rate.

# %%
forecastTermStructure$linkTo(depoFuturesSwapCurve)
showSwap(forward)

# %%
forecastTermStructure$linkTo(depoFraSwapCurve)
showSwap(forward)

## expanded to follow european-option.py

suppressMessages(library(QuantLib))

# global data
todaysDate <- Date(15, "May", 1998)
invisible(Settings_instance()$setEvaluationDate(d=todaysDate))
settlementDate <- Date(17, "May", 1998)
riskFreeRate <- FlatForward(settlementDate, 0.05, Actual365Fixed())

# option parameters
exercise <- EuropeanExercise(Date(17, "May", 1999))
payoff <- PlainVanillaPayoff("Call", 8.0)

# market data
underlying <- SimpleQuote(7.0)
volatility <- BlackConstantVol(todaysDate, TARGET(), 0.10, Actual365Fixed())
dividendYield <- FlatForward(settlementDate, 0.05, Actual365Fixed())

process <- BlackScholesMertonProcess(QuoteHandle(underlying),
                                     YieldTermStructureHandle(dividendYield),
                                     YieldTermStructureHandle(riskFreeRate),
                                     BlackVolTermStructureHandle(volatility))

cat(sprintf("%17s  %8s  %6s  %6s\n", "method", "value", "errest", "error"))
cat(rep("=", 43), "\n", sep="")
report <- function(method, x, dx=NA) {
    err <- abs(x - refValue)            # refValue is a global
    cat(sprintf("%17s  %8.5f  %6.4f  %6.4f\n", method, x, dx, err))
    invisible(NULL)
}

option <- VanillaOption(payoff, exercise)
invisible(option$setPricingEngine(AnalyticEuropeanEngine(process)))
value <- option$NPV()
refValue <- value
report("analytic", value)

invisible(option$setPricingEngine(IntegralEngine(process)))
report('integral', option$NPV())

## method: finite differences
timeSteps <- 801
gridPoints <- 800

invisible(option$setPricingEngine(FdBlackScholesVanillaEngine(process,timeSteps,gridPoints)))
report('finite diff.', option$NPV())


## method: binomial
timeSteps <- 801

invisible(option$setPricingEngine(BinomialJRVanillaEngine(process,timeSteps)))
report('binomial (JR)', option$NPV())

invisible(option$setPricingEngine(BinomialCRRVanillaEngine(process,timeSteps)))
report('binomial (CRR)', option$NPV())

invisible(option$setPricingEngine(BinomialEQPVanillaEngine(process,timeSteps)))
report('binomial (EQP)', option$NPV())

invisible(option$setPricingEngine(BinomialTrigeorgisVanillaEngine(process,timeSteps)))
report('bin. (Trigeorgis)', option$NPV())

invisible(option$setPricingEngine(BinomialTianVanillaEngine(process,timeSteps)))
report('binomial (Tian)', option$NPV())

invisible(option$setPricingEngine(BinomialLRVanillaEngine(process,timeSteps)))
report('binomial (LR)', option$NPV())

## method: Monte Carlo
invisible(option$setPricingEngine(MCLDEuropeanEngine(process,
                                  timeSteps = 1,
                                  timeStepsPerYear = NA,
                                  brownianBridge = FALSE,
                                  antitheticVariate = FALSE,
                                  requiredSamples = NA,
                                  requiredTolerance = 0.02,
                                  maxSamples = NA,
                                  seed = 42)))
report('MC (crude)', option$NPV()) #, option$errorEstimate())

invisible(option$setPricingEngine(MCLDEuropeanEngine(process,
                                  timeSteps = 1,
                                  timeStepsPerYear = NA,
                                  brownianBridge = FALSE,
                                  antitheticVariate = FALSE,
                                  requiredSamples = 32768,
                                  requiredTolerance = NA,
                                  maxSamples = NA,
                                  seed = 42)))
report('MC (Sobol)', option$NPV())

suppressMessages(library(QuantLib))

quote <- function(x) { sapply(x, function(x1) {
    todaysDate <- Date(15, "May", 1998)
    Settings_instance()$setEvaluationDate(d=todaysDate)
    settlementDate <- Date(17, "May", 1998)
    riskFreeRate <- FlatForward(settlementDate, 0.05, Actual365Fixed())
    exercise <- EuropeanExercise(Date(17, "May", 1999))
    payoff <- PlainVanillaPayoff("Call", 8.0)
    underlying <- SimpleQuote(x1)
    volatility <- BlackConstantVol(todaysDate, TARGET(), 0.10, Actual365Fixed())
    dividendYield <- FlatForward(settlementDate, 0.05, Actual365Fixed())
    process <- BlackScholesMertonProcess(QuoteHandle(underlying),
                                         YieldTermStructureHandle(dividendYield),
                                         YieldTermStructureHandle(riskFreeRate),
                                         BlackVolTermStructureHandle(volatility))
    option <- VanillaOption(payoff, exercise)
    Instrument_setPricingEngine(option, s_arg2=AnalyticEuropeanEngine(process))
    value <- option$NPV()
    value
})}

curve(quote,xlim=c(1,20))

# inspired by python example with the same name

suppressMessages(library(QuantLib))

## global data
calendar <- TARGET()

todaysDate <- Date(19, "October", 2020)
invisible(Settings_instance()$setEvaluationDate(d=todaysDate))

settlementDays <- 3
settlementDate <- Calendar_advance(calendar, todaysDate, settlementDays, "Days")

cat('Today          : ', todaysDate$`__str__`(), "\n")
cat('Settlement Date: ', settlementDate$`__str__`(), "\n")

# ### Term structure construction

# %%
dates = DateVector()
DateVector_append(dates, DateParser_parseISO("2020-10-19"))
DateVector_append(dates, DateParser_parseISO("2020-11-19"))

DateVector_append(dates, DateParser_parseISO("2021-01-19"))
DateVector_append(dates, DateParser_parseISO("2021-04-19"))
DateVector_append(dates, DateParser_parseISO("2021-10-19"))

DateVector_append(dates, DateParser_parseISO("2022-04-19"))
DateVector_append(dates, DateParser_parseISO("2022-10-19"))

DateVector_append(dates, DateParser_parseISO("2023-10-19"))
DateVector_append(dates, DateParser_parseISO("2025-10-19"))
DateVector_append(dates, DateParser_parseISO("2030-10-19"))
DateVector_append(dates, DateParser_parseISO("2035-10-19"))
DateVector_append(dates, DateParser_parseISO("2040-10-19"))

DateVector_size(dates)

rates = c(
    -0.004,
    -0.002,
    0.001,
    0.005,
    0.009,
    0.010,
    0.010,
    0.012,
    0.017,
    0.019,
    0.028,
    0.032
)

length(rates)

forecast_curve = ZeroCurve(dates, rates, Actual365Fixed())
forecast_handle = YieldTermStructureHandle(forecast_curve)

# ### Swap construction
#
# We'll use an overnight swap as an example.  
# We're keeping the initialization simple, 
# but the analysis work in the same way for more complex ones, 
# as well as for other kinds of swaps and bonds (once we extract the cashflows from them using the proper methods).

# %%
swapBuilder = MakeOIS(swapTenor=Period(5, "Years"),
                  overnightIndex=Eonia(forecast_handle),
                  fixedRate=0.002)

swap = MakeOIS_makeOIS(swapBuilder)

# ### Cash-flow analysis
#
# The fixed-rate coupons can be extracted from the swap using the `fixedLeg` method.  
#

fixed_leg = swap$fixedLeg()
CashFlows_maturityDate(fixed_leg)

df = NULL
for (i in seq(1, fixed_leg$size())) {
  cfl = fixed_leg[i][[1]]
  df = rbind(df, data.frame(date=Date_ISO(CashFlow_date(cfl)), amount=CashFlow_amount(cfl)))
}
print(df)


#
# If we want to extract more information, we need to upcast the coupons to a more specific class.  
# This can be done by using the `as_coupon` or the `as_fixed_rate_coupon` method. 
#

df = NULL
for (i in seq(1, fixed_leg$size())) {
  cfl = fixed_leg[i][[1]]
  cflCoupon = as_coupon(cfl)
  cflCouponFix = as_fixed_rate_coupon(cfl)
  cflCouponFixIr = FixedRateCoupon_interestRate(cflCouponFix)
  
  df = rbind(df, data.frame(date=Date_ISO(CashFlow_date(cfl)), amount=CashFlow_amount(cfl), 
                            accrualStartDate=Date_ISO(Coupon_accrualStartDate(cflCoupon)),
                            accrualEndDate=Date_ISO(Coupon_accrualEndDate(cflCoupon)),
                            accrualPeriod=Coupon_accrualPeriod(cflCoupon),
                            accrualDays=Coupon_accrualDays(cflCoupon),
                            accrualDayCounter=DayCounter_name(Coupon_dayCounter(cflCoupon)),
                            accruedAmount=Coupon_accruedAmount(self = cflCoupon, todaysDate),
                            rate=InterestRate_rate(cflCouponFixIr), rateDayCount=DayCounter_name(InterestRate_dayCounter(cflCouponFixIr))
                            ))
}
print(df)



# %%
floating_leg = swap$overnightLeg()

# %%
df = NULL
for (i in seq(1, floating_leg$size())) {
  cfl = floating_leg[i][[1]]
  cflCoupon = as_coupon(cfl)
  cflCouponFloat = as_floating_rate_coupon(cfl)
  cflCouponFloatIdx = FloatingRateCoupon_index(cflCouponFloat)
  
  
  df = rbind(df, data.frame(date=Date_ISO(CashFlow_date(cfl)), amount=CashFlow_amount(cfl), 
                            accrualStartDate=Date_ISO(Coupon_accrualStartDate(cflCoupon)),
                            accrualEndDate=Date_ISO(Coupon_accrualEndDate(cflCoupon)),
                            accrualPeriod=Coupon_accrualPeriod(cflCoupon),
                            accrualDays=Coupon_accrualDays(cflCoupon),
                            accrualDayCounter=DayCounter_name(Coupon_dayCounter(cflCoupon)),
                            accruedAmount=Coupon_accruedAmount(self = cflCoupon, todaysDate),
                            spread=FloatingRateCoupon_spread(cflCouponFloat),
                            gearing=FloatingRateCoupon_gearing(cflCouponFloat),
                            adjFix=FloatingRateCoupon_adjustedFixing(cflCouponFloat),
                            dtFix=Date_ISO(FloatingRateCoupon_fixingDate(cflCouponFloat)),
                            convexityAdj=FloatingRateCoupon_convexityAdjustment(cflCouponFloat)
  ))
}

print(df)

suppressMessages(library(QuantLib))

## global data
calendar <- TARGET()

settlementDate <- Date(15, "May", 1998)
settlementDate <- Calendar_adjust(calendar, settlementDate)

fixingDays <- 3
settlementDays <- 3
todaysDate <- Calendar_advance(calendar, settlementDate, -fixingDays, "Days")
invisible(Settings_instance()$setEvaluationDate(d=todaysDate))

cat('Today          : ', todaysDate$`__str__`(), "\n")
cat('Settlement Date: ', settlementDate$`__str__`(), "\n")


## option
exercise = AmericanExercise(todaysDate, Date(17, "May", 1999))
payoff = PlainVanillaPayoff("Put", 40.0)
option = VanillaOption(payoff, exercise)


# ### Market data

# %%
underlying = SimpleQuote(36.0)
dividendYield = FlatForward(todaysDate, 0.00, Actual365Fixed())
volatility = BlackConstantVol(todaysDate, calendar, 0.20, Actual365Fixed())
riskFreeRate = FlatForward(todaysDate, 0.06, Actual365Fixed())

# %%
process = BlackScholesMertonProcess(
    QuoteHandle(underlying),
    YieldTermStructureHandle(dividendYield),
    YieldTermStructureHandle(riskFreeRate),
    BlackVolTermStructureHandle(volatility)
)

# ### Pricing
# We'll collect tuples of method name, option value, and estimated error from the analytic formula.

# %%
results = NULL

# #### Analytic approximations

option$setPricingEngine(BaroneAdesiWhaleyApproximationEngine(process))
results = rbind(results, data.frame("method"="Barone-Adesi-Whaley", "NPV"=option$NPV()))

option$setPricingEngine(BjerksundStenslandApproximationEngine(process))
results = rbind(results, data.frame("method"="Bjerksund-Stensland", "NPV"=option$NPV()))


# #### Finite-difference method

timeSteps = 801
gridPoints = 800

option$setPricingEngine(FdBlackScholesVanillaEngine(process, timeSteps, gridPoints))
results = rbind(results, data.frame("method"="finite differences", "NPV"=option$NPV()))


# #### Binomial method

timeSteps = 801

# %%
listEngineFuncsNames = lsf.str("package:QuantLib")
listEngineFuncsNames = listEngineFuncsNames[grepl(pattern = "^Binomial", x = listEngineFuncsNames)]
listEngineFuncsNames = listEngineFuncsNames[grepl(pattern = "VanillaEngine$", x = listEngineFuncsNames)]

for (engineFuncName in listEngineFuncsNames) {
  eval(parse(text=paste0("option$setPricingEngine(", engineFuncName, "(process, timeSteps))")))
  results = rbind(results, data.frame("method"=engineFuncName, "NPV"=option$NPV()))
}


# ### Results
print(results)

# inspired by python example with the same name

suppressMessages(library(QuantLib))

## global data
calendar <- TARGET()

todaysDate <- DateParser_parseISO("2019-09-26")
invisible(Settings_instance()$setEvaluationDate(d=todaysDate))

settlementDays <- 2
settlementDate <- Calendar_advance(calendar, todaysDate, settlementDays, "Days")

cat('Today          : ', Date_ISO(todaysDate), "\n")
cat('Settlement Date: ', Date_ISO(settlementDate), "\n")

spot = settlementDate

# %% [markdown]
# ### Data
#
# We'll use the following data as input:

# %%
refMktRates = c(
    -0.373,
    -0.388,
    -0.402,
    -0.418,
    -0.431,
    -0.441,
    -0.45,
    -0.457,
    -0.463,
    -0.469,
    -0.461,
    -0.463,
    -0.479,
    -0.4511,
    -0.45418,
    -0.439,
    -0.4124,
    -0.37703,
    -0.3335,
    -0.28168,
    -0.22725,
    -0.1745,
    -0.12425,
    -0.07746,
    0.0385,
    0.1435,
    0.17525,
    0.17275,
    0.1515,
    0.1225,
    0.095,
    0.0644
)

# ### Market instruments

# %%
index = Euribor6M()

# The first market rate is for the 6-months deposit...

# %%
helpers = RateHelperVector()

helpers$append(
    DepositRateHelper(
        refMktRates[1] / 100.0, Period(6, "Months"), 2, calendar, "ModifiedFollowing", T, Actual360()
    )
)

# ...the next 12 are for FRAs...

# %%
for (i in seq(2, 13)) {
  helpers$append(
    FraRateHelper(refMktRates[i] / 100.0, i + 1, index)
  )
}

# ...and the others are swap rates.

# %%
swapTenors = c(2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 15, 20, 25, 30, 35, 40, 45, 50)

for (i in seq(14, length(refMktRates))) {
  r = refMktRates[i]
  tenor = swapTenors[i-13]
  helpers$append(
    SwapRateHelper(
      r / 100.0, Period(tenor, "Years"), calendar, "Annual", "ModifiedFollowing", Thirty360(Thirty360_BondBasis_get()), index
    )
  )
}

# We'll also add a few synthetic helpers:

# %%
additional_helpers = RateHelperVector()
for (i in seq(0, 6)){
  additional_helpers$append(
    FraRateHelper(-0.004, 12 + i, index) 
  )
}

# %%
additional_dates = DateVector()
for (i in seq(0, 4)){
  additional_dates$append(
    Calendar_advance(calendar, spot, Period(i+1, "Months"))
  )
}



# ### Global bootstrap
#
# This curve takes into account the market instruments, as well as the passed additional ones.

# %%
curve = GlobalLinearSimpleZeroCurve(
    spot, helpers, Actual365Fixed(), GlobalBootstrap(additional_helpers, additional_dates, 1.0e-4)
)
curve$enableExtrapolation()


# ### Report
df = NULL
for (i in seq(1, helpers$size())) {
  h = helpers[i][[1]]
  pillar = RateHelper_pillarDate(h)
  
  day_counter = Actual360()
  compounding = "Simple"
  if (i > 13) {
    day_counter = Thirty360(Thirty360_BondBasis_get())
    compounding = "SimpleThenCompounded"
  }

  r = YieldTermStructure_zeroRate(curve, pillar, day_counter, compounding, "Annual")
  
  df = rbind(df, data.frame(
    pillar=Date_ISO(pillar), zeroRate=InterestRate_rate(r)*100.0
  ))
}
print(df)

suppressMessages(library(QuantLib))

quote <- function(x) { sapply(x, function(x1) {
  todaysDate <- Date(15, "May", 1998)
  invisible(Settings_instance()$setEvaluationDate(d=todaysDate))
  settlementDate <- Date(17, "May", 1998)
  riskFreeRate <- FlatForward(settlementDate, 0.05, Actual365Fixed())
  exercise <- EuropeanExercise(Date(17, "May", 1999))
  payoff <- PlainVanillaPayoff("Call", 8.0)
  underlying <- SimpleQuote(x1)
  volatility <- BlackConstantVol(todaysDate, TARGET(), 0.10, Actual365Fixed())
  dividendYield <- FlatForward(settlementDate, 0.05, Actual365Fixed())
  process <- BlackScholesMertonProcess(QuoteHandle(underlying),
                                       YieldTermStructureHandle(dividendYield),
                                       YieldTermStructureHandle(riskFreeRate),
                                       BlackVolTermStructureHandle(volatility))
  option <- VanillaOption(payoff, exercise)
  invisible(option$setPricingEngine(s_arg2=FdBlackScholesVanillaEngine(process, 25)))
  option$NPV()
})}

curve(quote,xlim=c(1,20))

suppressMessages(library(QuantLib))
library(lattice)
library(grid)

spot<-seq(10.0,95.00,len=20)
vol<-seq(0.20,1.0,len=20)
g<-expand.grid(spot=spot,vol=vol)

todaysDate <- Date(15, "May", 1998)
Settings_instance()$setEvaluationDate(d=todaysDate)
settlementDate <- Date(17, "May", 1998)
riskQuote <- SimpleQuote(0.05)
riskFreeRate <- FlatForward(settlementDate, QuoteHandle(riskQuote),
	     Actual365Fixed())
exercise <- EuropeanExercise(Date(17, "May", 1999))
payoff <- PlainVanillaPayoff("Call", 50.0)
dividendYield <- FlatForward(settlementDate, 0.05, Actual365Fixed())
underlying <- SimpleQuote(10.0)

volatilityQuote <- SimpleQuote(0.05)
volatility <- BlackConstantVol(todaysDate, TARGET(),
	   QuoteHandle(volatilityQuote),
	      Actual365Fixed())
process <- BlackScholesMertonProcess(QuoteHandle(underlying),
		YieldTermStructureHandle(dividendYield),
		YieldTermStructureHandle(riskFreeRate),
		BlackVolTermStructureHandle(volatility))
engine <- AnalyticEuropeanEngine(process)
option <- VanillaOption(payoff, exercise)
option$setPricingEngine(s_arg2=engine)

t <- mapply(function(x,y) {
underlying$setValue(value=x)
volatilityQuote$setValue(value=y)
list(NPV=option$NPV(), gamma=option$gamma(),
	delta=option$delta(), vega=option$vega())},
	g$spot, g$vol, SIMPLIFY=FALSE)

g$NPV <- sapply(1:length(t), function(x) t[[x]]$NPV)
g$gamma <- sapply(1:length(t), function(x) t[[x]]$gamma)
g$delta <- sapply(1:length(t), function(x) t[[x]]$delta)
g$vega <- sapply(1:length(t), function(x) t[[x]]$vega)
par(mfrow = c(2,3))
plot <- vector("list",10)
plot[[1]] <- wireframe(NPV ~ spot*vol, g, drape=TRUE)
plot[[2]] <- wireframe(gamma ~ spot*vol, g, drape=TRUE)
plot[[3]] <- wireframe(delta ~ spot*vol, g, drape=TRUE)
plot[[4]] <- wireframe(vega ~ spot*vol, g, drape=TRUE)

grid.newpage()
pushViewport(viewport(layout=grid.layout(2,2)))
for (i in 1:4) {
pushViewport(viewport(layout.pos.col=((i - 1) %% 2) + 1,
            layout.pos.row=((i - 1) %/% 2) + 1))
  print(plot[[i]], newpage=FALSE)
	  popViewport()
}
popViewport()

## bonds.R -- following what bonds.py does for the QuantLib bindings for Python

suppressMessages(library(QuantLib))

## global data
calendar <- TARGET()

settlementDate <- Date(18, "September", 2008)
settlementDate <- Calendar_adjust(calendar, settlementDate)

fixingDays <- 3
settlementDays <- 3
todaysDate <- Calendar_advance(calendar, settlementDate, -fixingDays, "Days")
invisible(Settings_instance()$setEvaluationDate(d=todaysDate))

cat('Today          : ', todaysDate$`__str__`(), "\n")
cat('Settlement Date: ', settlementDate$`__str__`(), "\n")

## market quotes
## constructing bond yield curve
zcQuotes <- list(rates=c(0.0096, 0.0145, 0.0194),
                 tenor=c(Period(3, "Months"),
                 Period(6, "Months"),
                 Period(1, "Years")))

zcBondsDayCounter <- Actual365Fixed()

bondInstruments <- RateHelperVector()

for (i in 1:3) {
    r <- zcQuotes[["rates"]][i]
    tenor <- zcQuotes[["tenor"]][[i]]
    drh <- DepositRateHelper(QuoteHandle(SimpleQuote(r)),
                             tenor,
                             fixingDays,
                             calendar,
                             "ModifiedFollowing",
                             TRUE,
                             zcBondsDayCounter)
    RateHelperVector_push_back(bondInstruments, drh)
}

## setup bonds
redemption <- 100.0
numberOfBonds <- 5

bondQuotes <- list(list(Date(15,"March",2005),
                        Date(31,"August",2010),
                        0.02375, 100.390625),
                   list(Date(15,"June",2005),
                        Date(31,"August",2011),
                        0.04625, 106.21875),
                   list(Date(30,"June",2006),
                        Date(31,"August",2013),
                        0.03125, 100.59375),
                   list(Date(15,"November",2002),
                        Date(15,"August",2018),
                        0.04000, 101.6875),
                   list(Date(15,"May",1987),
                        Date (15,"May",2038),
                        0.04500, 102.140625)
                   )

# Definition of the rate helpers
for (i in 1:5) {
    issueDate <- bondQuotes[[i]][[1]]
    maturity <- bondQuotes[[i]][[2]]
    couponRate <- bondQuotes[[i]][[3]]
    marketQuote <- bondQuotes[[i]][[4]]
    schedule <- Schedule(issueDate, maturity, Period("Semiannual"),
                         UnitedStates("GovernmentBond"),
                         "Unadjusted", "Unadjusted",
                         copyToR(DateGeneration(), "Backward"),
                         FALSE)

    bh <- FixedRateBondHelper(QuoteHandle(SimpleQuote(marketQuote)),
                              settlementDays,
                              100.0,
                              schedule,
                              couponRate,
                              ActualActual("Bond"),
                              "Unadjusted",
                              redemption,
                              issueDate)
    RateHelperVector_push_back(bondInstruments, bh)
}
termStructureDayCounter <-  ActualActual("ISDA")

# not needed as defined in the interface file:  tolerance = 1.0e-15

bondDiscountingTermStructure <- PiecewiseFlatForward(settlementDate,
                                                     bondInstruments,
                                                     termStructureDayCounter)


# Building of the Libor forecasting curve
# deposits
dQuotes <- list(list(0.043375,  Period(1,"Weeks")),
                list(0.031875,  Period(1,"Months")),
                list(0.0320375, Period(3,"Months")),
                list(0.03385,   Period(6,"Months")),
                list(0.0338125, Period(9,"Months")),
                list(0.0335125, Period(1,"Years")))
sQuotes <- list(list(0.0295, Period(2,"Years")),
                list(0.0323, Period(3,"Years")),
                list(0.0359, Period(5,"Years")),
                list(0.0412, Period(10,"Years")),
                list(0.0433, Period(15,"Years")))

## deposits
depositDayCounter <- Actual360()
depoSwapInstruments <- RateHelperVector()

for (i in 1:length(dQuotes)) {
    rate  <- dQuotes[[i]][[1]]
    tenor <- dQuotes[[i]][[2]]
    drh <- DepositRateHelper(QuoteHandle(SimpleQuote(rate)),
                             tenor, fixingDays,
                             calendar, "ModifiedFollowing",
                             TRUE, depositDayCounter)
    RateHelperVector_push_back(depoSwapInstruments, drh)
}


## swaps
swFixedLegFrequency <- "Annual"
swFixedLegConvention <- "Unadjusted"
swFixedLegDayCounter <- Thirty360("European")
swFloatingLegIndex <- Euribor6M()
forwardStart <- Period(1,"Days")
for (i in 1:length(sQuotes)) {
    rate  <- sQuotes[[i]][[1]]
    tenor <- sQuotes[[i]][[2]]
    srh <- SwapRateHelper(QuoteHandle(SimpleQuote(rate)), tenor,
                          calendar, swFixedLegFrequency,
                          swFixedLegConvention, swFixedLegDayCounter,
                          swFloatingLegIndex, QuoteHandle(),forwardStart)
    RateHelperVector_push_back(depoSwapInstruments, srh)
}

depoSwapTermStructure <- PiecewiseFlatForward(settlementDate, depoSwapInstruments,
                                              termStructureDayCounter)

## Term structures that will be used for pricing:
## the one used for discounting cash flows

discountingTermStructure <- RelinkableYieldTermStructureHandle()

## the one used for forward rate forecasting
forecastingTermStructure <- RelinkableYieldTermStructureHandle()

########################################
##        BONDS TO BE PRICED           #
########################################

## common data

faceAmount <- 100

## pricing engine
bondEngine <- DiscountingBondEngine(discountingTermStructure)

## zero coupon bond
zeroCouponBond <- ZeroCouponBond(settlementDays,
                                 UnitedStates("GovernmentBond"),
                                 faceAmount,
                                 Date(15,"August",2013),
                                 "Following",
                                 116.92,
                                 Date(15,"August",2003))

invisible(Instrument_setPricingEngine(zeroCouponBond, bondEngine))

## fixed 4.5% US Treasury note

fixedBondSchedule <- Schedule(Date(15, "May", 2007),
                              Date(15, "May",2017), Period("Semiannual"),
                              UnitedStates("GovernmentBond"),
                              "Unadjusted", "Unadjusted",
                              copyToR(DateGeneration(), "Backward"), FALSE)

fixedRateBond <- FixedRateBond(settlementDays,
                               faceAmount,
                               fixedBondSchedule,
                               0.045,
                               ActualActual("Bond"),
                               "ModifiedFollowing",
                               100.0, Date(15, "May", 2007))
invisible(Instrument_setPricingEngine(fixedRateBond, bondEngine))

## Floating rate bond (3M USD Libor + 0.1%)
## Should and will be priced on another curve later...

liborTermStructure <- RelinkableYieldTermStructureHandle()

libor3m <- USDLibor(Period(3,"Months"),liborTermStructure)
invisible(Index_addFixing(libor3m, Date(17, "July", 2008), 0.0278625))

floatingBondSchedule <- Schedule(Date(21, "October", 2005),
                                 Date(21, "October", 2010), Period("Quarterly"),
                                 UnitedStates("NYSE"),
                                 "Unadjusted", "Unadjusted",
                                 copyToR(DateGeneration(), "Backward"), TRUE)

floatingRateBond <- FloatingRateBond(settlementDays,
                                     faceAmount,
                                     floatingBondSchedule,
                                     libor3m,
                                     Actual360(),
                                     "ModifiedFollowing",
                                     2,
                                     1.0,         # Gearings
                                     0.001,       # Spreads
                                     numeric(0),  #[],      # Caps
                                     numeric(0),  #[],      # Floors
                                     TRUE,    # Fixing in arrears
                                     100.0,
                                     Date(21, "October", 2005))

invisible(Instrument_setPricingEngine(floatingRateBond, bondEngine))

## coupon pricers

pricer <- BlackIborCouponPricer()

## optionlet volatilities
volatility <- 0.0
vol <- ConstantOptionletVolatility(settlementDays,
                                   calendar,
                                   "ModifiedFollowing",
                                   volatility,
                                   Actual365Fixed())

invisible(IborCouponPricer_setCapletVolatility(pricer, OptionletVolatilityStructureHandle(vol)))
invisible(setCouponPricer(Bond_cashflows(floatingRateBond), pricer))


## Yield curve bootstrapping
invisible(RelinkableYieldTermStructureHandle_linkTo(forecastingTermStructure, depoSwapTermStructure))
invisible(RelinkableYieldTermStructureHandle_linkTo(discountingTermStructure, bondDiscountingTermStructure))

## We are using the depo & swap curve to estimate the future Libor rates
invisible(RelinkableYieldTermStructureHandle_linkTo(liborTermStructure, depoSwapTermStructure))

##
df <- data.frame(zeroCoupon=c(Instrument_NPV(zeroCouponBond),
                   Bond_cleanPrice(zeroCouponBond),
                   Bond_dirtyPrice(zeroCouponBond),
                   Bond_accruedAmount(zeroCouponBond),
                   NA,
                   NA,
                   100*Bond_yield(zeroCouponBond, Actual360(), "Compounded", "Annual")),
                 fixedRate=c(Instrument_NPV(fixedRateBond),
                   Bond_cleanPrice(fixedRateBond),
                   Bond_dirtyPrice(fixedRateBond),
                   Bond_accruedAmount(fixedRateBond),
                   100*Bond_previousCouponRate(fixedRateBond),
                   100*Bond_nextCouponRate(fixedRateBond),
                   100*Bond_yield(fixedRateBond, Actual360(), "Compounded", "Annual")),
                 floatingRate=c(Instrument_NPV(floatingRateBond),
                   Bond_cleanPrice(floatingRateBond),
                   Bond_dirtyPrice(floatingRateBond),
                   Bond_accruedAmount(floatingRateBond),
                   100*Bond_previousCouponRate(floatingRateBond),
                   100*Bond_nextCouponRate(floatingRateBond),
                   100*Bond_yield(floatingRateBond, Actual360(), "Compounded", "Annual")),
                 row.names=c("NPV", "Clean Price", "Dirty Price",
                 "Accrued Amount", "Previous Coupon", "Next Coupon", "Yield"))
cat("\nResults:\n")
print(df, digits=5)

# Other computations

cat("\nSample indirect computations (for the floating rate bond):\n")
yld <- Bond_yield(floatingRateBond, Actual360(), "Compounded", "Annual")
clnPrc <- Bond_cleanPrice(floatingRateBond, yld, Actual360(), "Compounded", "Annual", settlementDate)
cat("Yield to Clean Price: ", clnPrc, "\n")
yld <- Bond_yield(floatingRateBond, BondPrice(clnPrc, BondPrice_Clean_get()), Actual360(), "Compounded", "Annual",settlementDate)
cat("Clean Price to Yield: ", yld, "\n")

# inspired by python example with the same name

suppressMessages(library(QuantLib))

## global data
calendar <- TARGET()

todaysDate <- DateParser_parseISO("2007-05-15")
invisible(Settings_instance()$setEvaluationDate(d=todaysDate))

settlementDays <- 3
settlementDate <- Calendar_advance(calendar, todaysDate, settlementDays, "Days")

cat('Today          : ', Date_ISO(todaysDate), "\n")
cat('Settlement Date: ', Date_ISO(settlementDate), "\n")

risk_free_rate = YieldTermStructureHandle(FlatForward(todaysDate, 0.01, Actual365Fixed()))

# ### CDS parameters

recovery_rate = 0.5
quoted_spreads = c(0.0150, 0.0150, 0.0150, 0.0150)

tenors = PeriodVector()
tenors$append(Period(3, "Months"))
tenors$append(Period(6, "Months"))
tenors$append(Period(1, "Years"))
tenors$append(Period(2, "Years"))

maturities = DateVector()
for (i in seq(1, tenors$size())) {
  maturities$append(
    Calendar_adjust(calendar,
                    Calendar_advance(calendar, todaysDate, tenors[i][[1]]),
                    "Following")
  )  
}

instruments = DefaultProbabilityHelperVector()
for (i in seq(1, length(quoted_spreads))) {
  s = quoted_spreads[i]
  tenor = tenors[i][[1]]
  
  it = SpreadCdsHelper(
    QuoteHandle(SimpleQuote(s)),
    tenor,
    0,
    calendar,
    "Quarterly",
    "Following",
    DateGeneration_TwentiethIMM_get(),
    Actual365Fixed(),
    recovery_rate,
    risk_free_rate
  )
  
  instruments$append(it) 
}

hazard_curve = PiecewiseFlatHazardRate(todaysDate, instruments, Actual365Fixed())

print("Calibrated hazard rate values: ")
for (i in seq(1, hazard_curve$dates()$size())) {
  print(paste("hazard rate on ", 
              Date_ISO(hazard_curve$dates()[i][[1]]), 
              "is ", 
              HazardRateCurve_hazardRates(hazard_curve)[i]))
}

print(paste("1Y survival probability:",
            DefaultProbabilityTermStructure_survivalProbability(hazard_curve, Calendar_advance(calendar, todaysDate, Period(1, "Years"))),
            "expected 0.9704 "
))

print(paste("2Y survival probability:",
            DefaultProbabilityTermStructure_survivalProbability(hazard_curve, Calendar_advance(calendar, todaysDate, Period(2, "Years"))),
            "expected 0.9418 "
))

# ### Reprice instruments

nominal = 1000000.0
probability = DefaultProbabilityTermStructureHandle(hazard_curve)

# We'll create a cds for every maturity:

print("Repricing of quoted CDSs employed for calibration: ")
for (i in seq(1, length(quoted_spreads))) {
  maturity = maturities[i][[1]]
  s = quoted_spreads[i]
  tenor = tenors[i][[1]]
  
  schedule = Schedule(
    todaysDate,
    maturity,
    Period(3, "Months"), # "Quarterly",
    calendar,
    "Following",
    "Unadjusted",
    DateGeneration_TwentiethIMM_get(),
    F
  )
  
  cds = CreditDefaultSwap(Protection_Seller_get(), nominal, s, schedule, "Following", Actual365Fixed())
  engine = MidPointCdsEngine(probability, recovery_rate, risk_free_rate)
  cds$setPricingEngine(engine)
  
  print(paste("fair spread: ", Period___str__(tenor), cds$fairSpread()))
  print(paste("   NPV: ", cds$NPV()))
  print(paste("   default leg: ", cds$defaultLegNPV()))
  print(paste("   coupon leg: ", cds$couponLegNPV()))
  print("")
  
}

suppressMessages(library(QuantLib))

spot<-seq(10.0,95.00,len=20)
vol<-0.5
g<-expand.grid(spot=spot,vol=vol)

todaysDate <- Date(15, "May", 1998)
Settings_instance()$setEvaluationDate(d=todaysDate)
settlementDate <- Date(17, "May", 1998)
riskQuote <- SimpleQuote(0.05)
riskFreeRate <- FlatForward(settlementDate, QuoteHandle(riskQuote),
                            Actual365Fixed())
exercise <- EuropeanExercise(Date(17, "May", 1999))
payoff <- PlainVanillaPayoff("Call", 50.0)
dividendYield <- FlatForward(settlementDate, 0.05, Actual365Fixed())
underlying <- SimpleQuote(10.0)
volatilityQuote <- SimpleQuote(0.05)
volatility <- BlackConstantVol(todaysDate, TARGET(),
                               QuoteHandle(volatilityQuote),
                               Actual365Fixed())
process <- BlackScholesMertonProcess(QuoteHandle(underlying),
                                     YieldTermStructureHandle(dividendYield),
                                     YieldTermStructureHandle(riskFreeRate),
                                     BlackVolTermStructureHandle(volatility))
engine <- AnalyticEuropeanEngine(process)
option <- VanillaOption(payoff, exercise)
option$setPricingEngine(s_arg2=engine)

t <- mapply(function(x,y) {
    underlying$setValue(value=x)
    volatilityQuote$setValue(value=y)
    list(NPV=option$NPV(), gamma=option$gamma(),
         delta=option$delta(), vega=option$vega())},
            g$spot, g$vol, SIMPLIFY=FALSE)

g$NPV <- sapply(1:length(t), function(x) t[[x]]$NPV)
g$gamma <- sapply(1:length(t), function(x) t[[x]]$gamma)
g$delta <- sapply(1:length(t), function(x) t[[x]]$delta)
g$vega <- sapply(1:length(t), function(x) t[[x]]$vega)
pairs(g)

suppressMessages(library(QuantLib))


bToday = QuantLib::Date(31, "August", 2022)
QuantLib::Settings_setEvaluationDate(self = QuantLib::Settings_instance(), d = bToday)
print(Settings_instance()$getEvaluationDate())

bufDates = QuantLib::DateVector()
QuantLib::DateVector_append(self = bufDates, x = Date(31, "August", 2022))
QuantLib::DateVector_append(self = bufDates, x = Date(30, "September", 2022))
QuantLib::DateVector_size(self = bufDates)

bCurve = QuantLib::DiscountCurve(dates = bufDates , discounts = c(1.0, 1.0), dayCounter = Actual360())

# inspired by python example with the same name

suppressMessages(library(QuantLib))

## global data
calendar <- TARGET()

todaysDate <- DateParser_parseISO("2014-04-30")
invisible(Settings_instance()$setEvaluationDate(d=todaysDate))

settlementDays <- 3
settlementDate <- Calendar_advance(calendar, todaysDate, settlementDays, "Days")

cat('Today          : ', Date_ISO(todaysDate), "\n")
cat('Settlement Date: ', Date_ISO(settlementDate), "\n")

refDate = todaysDate

# ### Calculations

# This exercise tries to replicate the Quantlib C++ `Gaussian1dModel` example on how to use the GSR and Markov Functional model.

# We assume a multicurve setup, for simplicity with flat yield term structures.
#
# The discounting curve is an Eonia curve at a level of 2% and the forwarding curve is an Euribor 6m curve at a level of 2.5%.
#
# For the volatility we assume a flat swaption volatility at 20%.


forward6mQuote = QuoteHandle(SimpleQuote(0.025))
oisQuote = QuoteHandle(SimpleQuote(0.02))
volQuote = QuoteHandle(SimpleQuote(0.2))

# %%
dc = Actual365Fixed()
yts6m = FlatForward(refDate, forward6mQuote, dc)
ytsOis = FlatForward(refDate, oisQuote, dc)
yts6m$enableExtrapolation()
ytsOis$enableExtrapolation()

hyts6m = RelinkableYieldTermStructureHandle(yts6m)
t0_curve = YieldTermStructureHandle(yts6m)
t0_Ois = YieldTermStructureHandle(ytsOis)
euribor6m = Euribor6M(hyts6m)
swaptionVol = ConstantSwaptionVolatility(0, calendar, "ModifiedFollowing", volQuote, Actual365Fixed())


# %%
effectiveDate = Calendar_advance(calendar, refDate, 2, "Days")
print(Date_ISO(effectiveDate))

maturityDate = Calendar_advance(calendar, effectiveDate, 10, "Years")
print(Date_ISO(maturityDate))

# %%
fixedSchedule = Schedule(effectiveDate,
                            maturityDate,
                            Period(1, "Years"),
                            calendar,
                            "ModifiedFollowing",
                            "ModifiedFollowing",
                            DateGeneration_Forward_get(), F)

# %%
floatSchedule = Schedule(effectiveDate,
                            maturityDate,
                            Period(6, "Months"),
                            calendar,
                            "ModifiedFollowing",
                            "ModifiedFollowing",
                            DateGeneration_Forward_get(), F)


# We consider a standard 10-years Bermudan payer swaption with yearly exercises at a strike of 4%.

# %%
fixedNominal    = rep(1, fixedSchedule$size()-1)
floatingNominal = rep(1, floatSchedule$size()-1)
strike          = rep(0.04, fixedSchedule$size()-1)
gearing         = rep(1, floatSchedule$size()-1)
spread          = rep(0, floatSchedule$size()-1)

# %%
underlying = NonstandardSwap(
    Swap_Payer_get(),
    fixedNominal, floatingNominal, fixedSchedule, strike,
    Thirty360(Thirty360_BondBasis_get()), floatSchedule,
    euribor6m, gearing, spread, Actual360(), F, F, "ModifiedFollowing")

# %%
exerciseDates = Schedule_dates(self = fixedSchedule, .copy = T)
for (i in seq(0, exerciseDates$size()-1)) { # C Style vector numbering
  DateVector___setitem__(exerciseDates, i, Calendar_advance(calendar, DateVector___getitem__(exerciseDates, i), -2, "Days"))
}

DateVector___delitem__(exerciseDates, 0)
DateVector___delitem__(exerciseDates, DateVector___len__(exerciseDates)-1)
for (i in seq(1, exerciseDates$size())) { # R style vector numbering
  print(exerciseDates[i][[1]])
}

exercise = BermudanExercise(exerciseDates)
swaption = NonstandardSwaption(underlying,exercise,Settlement_Physical_get())

# The model is a one factor Hull White model with piecewise volatility adapted to our exercise dates.
#
# The reversion is just kept constant at a level of 1%.

stepDates = DateVector(exerciseDates)
DateVector___delitem__(stepDates, DateVector___len__(stepDates)-1)

sigmas = QuoteHandleVector()
for (i in seq(1, 9)) {
  QuoteHandleVector_append(sigmas, QuoteHandle(SimpleQuote(0.01)))
}

reversion = QuoteHandleVector()
QuoteHandleVector_append(reversion, QuoteHandle(SimpleQuote(0.01)))

#
# The model's curve is set to the 6m forward curve. 
# Note that the model adapts automatically to other curves where appropriate 
# (e.g. if an index requires a different forwarding curve) or where explicitly specified (e.g. in a swaption pricing engine).


gsr = Gsr(t0_curve, stepDates, sigmas, reversion)
swaptionEngine = Gaussian1dSwaptionEngine(gsr, 64, 7.0, T, F, t0_Ois)
nonstandardSwaptionEngine = Gaussian1dNonstandardSwaptionEngine(
    gsr, 64, 7.0, T, F, QuoteHandle(SimpleQuote(0)), t0_Ois)

# %%
swaption$setPricingEngine(nonstandardSwaptionEngine)

# %%
swapBase = EuriborSwapIsdaFixA(Period(10, 'Years'), t0_curve, t0_Ois)
basket = swaption$calibrationBasket(swapBase, swaptionVol, 'Naive')

# %%
for (i in seq(1, basket$size())) {
  basket_i = basket[i][[1]]
  BlackCalibrationHelper_setPricingEngine(basket_i, swaptionEngine)
}
    

# %%
method = LevenbergMarquardt()
ec = EndCriteria(1000, 10, 1e-8, 1e-8, 1e-8)

# %%
gsr$calibrateVolatilitiesIterative(basket, method, ec)


# %% [markdown]
# The engine can generate a calibration basket in two modes.
#
# The first one is called Naive and generates ATM swaptions adapted to the exercise dates of the swaption and its maturity date. The resulting basket looks as follows:

# %%
basket_data = function(basket) {
  df = NULL
  for (i in seq(1, basket$size())) {
    basket_i = basket[i][[1]]
    h = as_swaption_helper(basket_i)
    hopt = SwaptionHelper_swaption(h)
    df = rbind(df, data.frame(expiry=Date_ISO(SwaptionHelper_swaptionExpiryDate(h)),
                              maturity=Date_ISO(SwaptionHelper_swaptionMaturityDate(h)),
                              nominal=SwaptionHelper_swaptionNominal(h),
                              strike=SwaptionHelper_swaptionStrike(h),
                              optType=Swaption_type(hopt)
                              
    ))
  }
  df
}  

print(basket_data(basket))




#
# Let's calibrate our model to this basket. 
# We use a specialized calibration method calibrating the sigma function one by one to the calibrating vanilla swaptions. The result of this is as follows:

# %%
calibration_data = function(basket, volatilities) {
  # volatilities = gsr$volatility()
  df = NULL
  for (i in seq(1, basket$size())) {
    basket_i = basket[i][[1]]
    vola_i = volatilities[i][[1]]
    h = as_swaption_helper(basket_i)
    hopt = SwaptionHelper_swaption(h)
    modelPrice = basket_i$modelValue()
    modelImpVol = BlackCalibrationHelper_impliedVolatility(self = basket_i, targetValue = modelPrice, accuracy = 1e-6, maxEvaluations = 1000, minVol = 0.0, maxVol = 2.0)
    marketPrice = basket_i$marketValue()
    
    df = rbind(df, data.frame(expiry=Date_ISO(SwaptionHelper_swaptionExpiryDate(h)),
                              modelSigma=vola_i,
                              modelPrice=modelPrice,
                              marketPrice=marketPrice,
                              modelImpVol=modelImpVol,
                              marketImpVol=QuoteHandle_value(basket_i$volatility())
    ))
  }  
                              
  df
}

print(calibration_data(basket, gsr$volatility()))

# %% [markdown]
# Bermudan swaption NPV (ATM calibrated GSR):

# %%
print(swaption$NPV())


#
# There is another mode to generate a calibration basket called `MaturityStrikeByDeltaGamma`.
# This means that the maturity, the strike and the nominal of the calibrating swaptions are obtained matching the NPV, 
# first derivative and second derivative of the swap you will exercise into at at each bermudan call date.
# The derivatives are taken with respect to the model's state variable.
#
# Let's try this in our case.

# %%
basket = swaption$calibrationBasket(swapBase, swaptionVol, 'MaturityStrikeByDeltaGamma')
print(basket_data(basket))

# %%
for (i in seq(1, basket$size())) {
  basket_i = basket[i][[1]]
  BlackCalibrationHelper_setPricingEngine(basket_i, swaptionEngine)
}


# %% [markdown]
# The calibrated nominal is close to the exotics nominal. The expiries and maturity dates of the vanillas are the same as in the case above. The difference is the strike which is now equal to the exotics strike.
#
# Let's see how this affects the exotics NPV. The recalibrated model is:

# %%
gsr$calibrateVolatilitiesIterative(basket, method, ec)
print(calibration_data(basket, gsr$volatility()))

# %% [markdown]
# Bermudan swaption NPV (deal strike calibrated GSR):

# %%
print(swaption$NPV())

# 
# We can do more complicated things.  
# Let's e.g. modify the nominal schedule to be linear amortizing and see what the effect on the generated calibration basket is:

# %%
for (i in seq(1,fixedSchedule$size()-1)) {
  tmp = 1.0 - i/ (fixedSchedule$size())
  fixedNominal[i]        = tmp
  floatingNominal[i*2-1]   = tmp
  floatingNominal[i*2] = tmp
}

# %%
underlying2 = NonstandardSwap(Swap_Payer_get(),
                            fixedNominal, floatingNominal, fixedSchedule, strike,
                            Thirty360(Thirty360_BondBasis_get()), floatSchedule,
                            euribor6m, gearing, spread, Actual360(), F, F, "ModifiedFollowing")

# %%
swaption2 = NonstandardSwaption(underlying2, exercise, Settlement_Physical_get())

# %%
swaption2$setPricingEngine(nonstandardSwaptionEngine)
basket = swaption2$calibrationBasket(swapBase, swaptionVol, 'MaturityStrikeByDeltaGamma')

# %%
print(basket_data(basket))

#
# The notional is weighted over the underlying exercised into and the maturity is adjusted downwards. The rate, on the other hand, is not affected.

#
# You can also price exotic bond's features. 
# If you have e.g. a Bermudan callable fixed bond you can set up the call right as a swaption 
# to enter into a one leg swap with notional reimbursement at maturity. 
# The exercise should then be written as a rebated exercise paying the notional in case of exercise. The calibration basket looks like this:

# %%
fixedNominal2    = rep(1, fixedSchedule$size()-1)
floatingNominal2 = rep(0, fixedSchedule$size()*2-2) #null the second leg

# %%
underlying3 = NonstandardSwap(Swap_Receiver_get(),
                            fixedNominal2, floatingNominal2, fixedSchedule, strike,
                            Thirty360(Thirty360_BondBasis_get()), floatSchedule,
                            euribor6m, gearing, spread, Actual360(), F, T, "ModifiedFollowing")

# %%
rebateAmount = rep(-1, exerciseDates$size())
exercise2 = RebatedExercise(exercise, rebateAmount, 2, calendar)
swaption3 = NonstandardSwaption(underlying3, exercise2, Settlement_Physical_get())

# %%
oas0 = SimpleQuote(0)
oas100 = SimpleQuote(0.01)
oas = RelinkableQuoteHandle(oas0)

# %%
nonstandardSwaptionEngine2 = Gaussian1dNonstandardSwaptionEngine(
    gsr, 64, 7.0, T, F, oas, t0_curve) # Change discounting to 6m

# %%
swaption3$setPricingEngine(nonstandardSwaptionEngine2)
basket = swaption3$calibrationBasket(swapBase, swaptionVol, 'MaturityStrikeByDeltaGamma')

# %%
print(basket_data(basket))

# %% [markdown]
# Note that nominals are not exactly 1.0 here. This is because we do our bond discounting on 6m level while the swaptions are still discounted on OIS level. (You can try this by changing the OIS level to the 6m level, which will produce nominals near 1.0).
#
# The NPV of the call right is (after recalibrating the model):

# %%
for (i in seq(1, basket$size())) {
  basket_i = basket[i][[1]]
  BlackCalibrationHelper_setPricingEngine(basket_i, swaptionEngine)
}

# %%
gsr$calibrateVolatilitiesIterative(basket, method, ec)

# %%
print(swaption3$NPV())

# %% [markdown]
# Up to now, no credit spread is included in the pricing. We can do so by specifying an oas in the pricing engine. Let's set the spread level to 100bp and regenerate the calibration basket.

# %%
oas$linkTo(oas100)
basket = swaption3$calibrationBasket(swapBase, swaptionVol, 'MaturityStrikeByDeltaGamma')
print(basket_data(basket))

# %% [markdown]
# The adjusted basket takes the credit spread into account. This is consistent to a hedge where you would have a margin on the float leg around 100bp,too.

# %%
for (i in seq(1, basket$size())) {
  basket_i = basket[i][[1]]
  BlackCalibrationHelper_setPricingEngine(basket_i, swaptionEngine)
}

# %%
gsr$calibrateVolatilitiesIterative(basket, method, ec)

# %%
print(swaption3$NPV())

library(QuantLib)
library(lattice)

todaysDate <- Date(18, "May", 2013)
Settings_instance()$setEvaluationDate(d=todaysDate)
settlementDate <- Date(18, "May", 2013)

riskFreeRate <- YieldTermStructureHandle(FlatForward(settlementDate, 0.01, Actual365Fixed()))

dividendYield <-  YieldTermStructureHandle(FlatForward(settlementDate, 0.04, Actual365Fixed()))

underlying <- QuoteHandle(SimpleQuote(100))

bsProcess <- BlackScholesMertonProcess(underlying, dividendYield, riskFreeRate,
                                       BlackVolTermStructureHandle(
                                           BlackConstantVol(todaysDate, TARGET(),
                                                            QuoteHandle(SimpleQuote(0.25)),
                                                            Actual365Fixed())))

strikes <- seq(20, 200, length=30)
maturities <- seq(0.25, 2, length=30)
g <- expand.grid(strikes=strikes, maturities=maturities)

batesEngine <- BatesEngine(BatesModel(BatesProcess(
    riskFreeRate, dividendYield, underlying,
    0.1, 1.5, 0.25, 0.75, -0.75, 0.75, -0.05, 0.3)), 128)

impliedVol <- function(strike, maturity) {
    exercise <- EuropeanExercise(Date(18, "May", 2013) +
                                 Period(maturity*365, "Days"))
    payoff <- PlainVanillaPayoff("Call", strike)
    option <- VanillaOption(payoff, exercise)
    option$setPricingEngine(s_arg2=batesEngine)
    VanillaOption_impliedVolatility(option,
                                    targetValue=option$NPV(),
                                    process=bsProcess,
                                    accuracy=1e-16,
                                    maxEvaluations=100,
                                    minVol=0.1,
                                    maxVol=5.1)
}

g$vol <- mapply(impliedVol, g$strikes, g$maturities)

newcols <- colorRampPalette(c("grey90", "grey10"))
print(wireframe(vol ~ strikes*maturities, g,
                xlab="Strike",ylab="Maturitiy",zlab="Vol",
                drape=TRUE,col.regions=rainbow(100,end=0.99,alpha=0.9),
                screen = list(z = -25, x = -65),scale=list(arrows=FALSE)))

# inspired by python example with the same name

suppressMessages(library(QuantLib))

## global data
calendar <- TARGET()

todaysDate <- Date(15, "May", 1998)
invisible(Settings_instance()$setEvaluationDate(d=todaysDate))

settlementDays <- 3
settlementDate <- Calendar_advance(calendar, todaysDate, settlementDays, "Days")

cat('Today          : ', todaysDate$`__str__`(), "\n")
cat('Settlement Date: ', settlementDate$`__str__`(), "\n")

riskFreeRate = FlatForward(settlementDate, 0.05, Actual365Fixed())


# ### Option parameters
exerciseDate = Date(17, "May", 1999)
exercise = EuropeanExercise(exerciseDate)
payoff = PlainVanillaPayoff("Call", 8.0)


# ### Market data
underlying1 = SimpleQuote(7.0)
volatility1 = BlackConstantVol(todaysDate, calendar, 0.10, Actual365Fixed())
dividendYield1 = FlatForward(settlementDate, 0.05, Actual365Fixed())
underlying2 = SimpleQuote(7.0)
volatility2 = BlackConstantVol(todaysDate, calendar, 0.10, Actual365Fixed())
dividendYield2 = FlatForward(settlementDate, 0.05, Actual365Fixed())


process1 = BlackScholesMertonProcess(
    QuoteHandle(underlying1),
    YieldTermStructureHandle(dividendYield1),
    YieldTermStructureHandle(riskFreeRate),
    BlackVolTermStructureHandle(volatility1)
)

process2 = BlackScholesMertonProcess(
    QuoteHandle(underlying2),
    YieldTermStructureHandle(dividendYield2),
    YieldTermStructureHandle(riskFreeRate),
    BlackVolTermStructureHandle(volatility2)
)

corrMatrix = Matrix(2, 2)
invisible(Matrix_setitem(corrMatrix, 0, 0, 1.0))
invisible(Matrix_setitem(corrMatrix, 1, 1, 1.0))
invisible(Matrix_setitem(corrMatrix, 1, 0, 0.5))
invisible(Matrix_setitem(corrMatrix, 0, 1, 0.5))
cat(corrMatrix$`__str__`())

procVector = StochasticProcess1DVector(2)
invisible(StochasticProcess1DVector___setitem__(self = procVector, i = 0, x = process1))
invisible(StochasticProcess1DVector___setitem__(self = procVector, i = 1, x = process2))

process = StochasticProcessArray(array = procVector, correlation = corrMatrix)

# ### Pricing - European

basketoption = BasketOption(MaxBasketPayoff(payoff), exercise)
basketoption$setPricingEngine(
  MCPREuropeanBasketEngine(process=process, timeSteps=NA, timeStepsPerYear=1, brownianBridge=F, antitheticVariate=F, requiredSamples=NA, requiredTolerance=0.02, maxSamples=10000, seed=42)
)
print(basketoption$NPV())

basketoption = BasketOption(MinBasketPayoff(payoff), exercise)
basketoption$setPricingEngine(
  MCPREuropeanBasketEngine(process=process, timeSteps=NA, timeStepsPerYear=1, brownianBridge=F, antitheticVariate=F, requiredSamples=NA, requiredTolerance=0.02, maxSamples=10000, seed=42)
)
print(basketoption$NPV())

basketoption = BasketOption(AverageBasketPayoff(payoff, 2), exercise)
basketoption$setPricingEngine(
  MCPREuropeanBasketEngine(process=process, timeSteps=NA, timeStepsPerYear=1, brownianBridge=F, antitheticVariate=F, requiredSamples=NA, requiredTolerance=0.02, maxSamples=10000, seed=42)
)
print(basketoption$NPV())


# ### Pricing - American

americanExercise = AmericanExercise(settlementDate, exerciseDate)
americanbasketoption = BasketOption(MaxBasketPayoff(payoff), americanExercise)
americanbasketoption$setPricingEngine(
  MCPRAmericanBasketEngine(
        process=process,
        timeSteps=10,
        timeStepsPerYear=NA,
        brownianBridge=F,
        antitheticVariate=F,
        requiredSamples=50000,
        requiredTolerance=0.02,
        maxSamples=100000,
        seed=42,
        nCalibrationSamples=5000,
        polynomOrder=5,
        polynomType=LsmBasisSystem_Hermite_get()
    )
)
print(americanbasketoption$NPV())

#!/bin/bash
set -e

# Setup Boost
curl -O -L https://archives.boost.io/release/1.90.0/source/boost_1_90_0.tar.gz
tar xfz boost_*.tar.gz
cd boost_*/
mv boost /usr/local/include/
cd ..

# Build QuantLib
cd QuantLib-1.*/
./configure --disable-static --enable-thread-safe-observer-pattern --disable-test-suite --enable-skip-examples --enable-unity-build CXXFLAGS="${CXXQLFLAGS}"
make -j 4 install
cd ..

#!/bin/bash
set -e

# Setup Boost
curl -O -L https://archives.boost.io/release/1.90.0/source/boost_1_90_0.tar.gz
tar xfz boost_*.tar.gz
cd boost_*/
mv boost /usr/local/include/
cd ..

# Build QuantLib
cd QuantLib-1.*/
./configure --disable-static --disable-test-suite --enable-skip-examples --enable-unity-build CXXFLAGS="${CXXQLFLAGS}"
make -j 4 install
cd ..
